/* Author: Profezzorn at nannymud <albert_e@lysator.liu.se> */
/* Last patched: Linus@lysator.liu.se */

inherit "/std/object";

get() { return 1; }
drop() { return 1; }
init() { add_action("profile","profilera"); }
short() { return "en profilerare"; }
long()
{
  write("Anv{nd s} h{r : profilera filnamn\n"+
	"Se till att objectet {r laddat.\n");
}

id(s) { return s=="profileraren"; }

string_number(n)
{
  if(n<0) n="";
  return (n+"                           ")[0..7];
}

profile(str)
{
  mixed *b;
  string *c,fil;
  object a;
  int e,q,p;
  string filename;

  notify_fail("Profilera vad?\n");
  if(!str) return 0;
  if (sizeof(explode(str,"/")) == 1)
      str = this_player()->query_path() + "/" + str;
  if(!(a=find_object(str))) return 0;
  b=lpcprof(a);
  c=explode(read_file(str+".c"),"\n");
  fil="";
  for(e=0,q=1;e<sizeof(c);e++)
  {
    if(q<sizeof(b) && b[q][0]==e+1)
    {
      p=b[q][1];
      q++;
    } 
    else
      p=-1;
    fil+=string_number(p)+c[e]+"\n";
  }

  filename = "/log/"+implode(explode(str,"/"),"_")+".prof";
  rm(filename);
  write_file(filename,fil);
  write("Klart. Profileringen skriven till " + filename + ".\n");
  return 1;
}
